namespace GasolineTanker
{
    public partial class FormGasolineTanker : Form
    {
        private DrawingGasolineTanker _gasolineTanker;
        public FormGasolineTanker()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _gasolineTanker?.DrawTransport(gr);
            pictureBoxGasolineTanker.Image = bmp;
        }
        private void PictureBoxCar_Resize(object sender, EventArgs e)
        {
            _gasolineTanker?.ChangeBorders(pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
            Draw();
        }

        private void buttonCreate_Click_1(object sender, EventArgs e)
        {
            Random rnd = new();
            _gasolineTanker = new DrawingGasolineTanker();
            _gasolineTanker.Init(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            _gasolineTanker.SetPosition(rnd.Next(10, 100),rnd.Next(50, 100), pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
            toolStripStatusSpeed.Text = $"Speed {_gasolineTanker.GasolineTanker.Speed}";
            toolStripStatusWeight.Text = $"Weight {_gasolineTanker.GasolineTanker.Weight}";
            toolStripStatusBodyColor.Text = $"Color {_gasolineTanker.GasolineTanker.BodyColor.Name}";
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "keyUp":
                    _gasolineTanker?.MoveTransport(Direction.Up);
                    break;
                case "keyDown":
                    _gasolineTanker?.MoveTransport(Direction.Down);
                    break;
                case "keyLeft":
                    _gasolineTanker?.MoveTransport(Direction.Left);
                    break;
                case "keyRight":
                    _gasolineTanker?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        private void PictureBoxGasolineTanker_Resize(object sender, EventArgs e)
        {
            _gasolineTanker?.ChangeBorders(pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
            Draw();
        }
    }
}